Option Explicit
Const STREETPASS_DELAY = 480
Const URL = "http://nintendozone.no-ip.org/?"
Dim BaseName: BaseName = Left(Wscript.ScriptName, InStrRev(Wscript.ScriptName, ".")-1)
Dim strArg: strArg = "BASE16"
If WScript.Arguments.Count > 0 Then strArg = WScript.Arguments.Item(0)
Select Case strArg
	Case "start"
		If StartHostedNetwork("") Then
			If WScript.Arguments.Count > 1 Then SchTasks(" /create /f /tr ""cscript " & WScript.ScriptFullName & " " & WScript.Arguments.Item(1) & """ /sc minute /mo 1 /ru ""system""") Else SchTasks(" /change /enable")
		End If
	Case "stop"
		SchTasks(" /change /disable")
		StopHostedNetwork
	Case "toggle", "restart"
		Dim CSCRIPT: CSCRIPT = "%systemroot%\system32\cscript.exe " & WScript.ScriptFullName & " "
		With CreateObject("WScript.Shell")
			If .Run(CSCRIPT & "status", 0, True) = 0 Then
				If strArg = "restart" Then 
					.Run CSCRIPT & "stop", 0, True
					.Run CSCRIPT & "start", 0, False
				Else
					.Run CSCRIPT & "stop", 0, False
				End If
			Else
				.Run CSCRIPT & "start", 0, False
			End If
		End With
	Case "reload", "force-reload"
		With CreateObject("Scripting.FileSystemObject")
		On Error Resume Next
			.DeleteFile(.GetParentFolderName(Wscript.ScriptFullName) & "\" & BaseName & ".macs"), True
		On Error Goto 0
		End With
	Case "status"
		If TaskEnabled Then
			WScript.Echo BaseName & " is running":Wscript.Quit(0)
		Else
			WScript.Echo BaseName & " is not running":Wscript.Quit(1)
		End If
	Case Else
		Dim colActiveMAC, strMAC, strAllMACs, intDelay, intActiveMACCount, intAllMACCount
		Dim objFSO: Set objFSO = CreateObject("Scripting.FileSystemObject")
		Dim strMACFile: strMACFile = objFSO.GetParentFolderName(Wscript.ScriptFullName) & "\" & BaseName & ".macs"
		Randomize
		If objFSO.FileExists(strMACFile) Then
			intDelay = DateDiff("n", objFSO.GetFile(strMACFile).DateLastModified, Now)
			strAllMACs = objFSO.OpenTextFile(strMACFile, 1).ReadAll
			Set colActiveMAC = Execute(strAllMACs, "^[^x].*$")
			intActiveMACCount = colActiveMAC.Count
		End If
		If intActiveMACCount = 0 Or Not objFSO.FileExists(strMACFile) Then
			With CreateObject("Microsoft.XMLHTTP")
				.Open "GET", URL & strArg, False
				.Send
				If Len(.ResponseText) > 0 Then
					If Not objFSO.FileExists(strMACFile) Then intDelay = STREETPASS_DELAY
					strAllMACs = .ResponseText
					objFSO.CreateTextFile(strMACFile, True).Write(strAllMACs)
				Else
					strAllMACs = Replace(strAllMACs, "^x", "")
				End If
			End With
			Set colActiveMAC = Execute(strAllMACs, "^[^x].*$")
			intActiveMACCount = colActiveMAC.Count
		End If
		intAllMACCount = Execute(strAllMACs, "\n").Count
		If intActiveMACCount > 0 And (intAllMACCount > 480 Or (intDelay >= (STREETPASS_DELAY/intAllMACCount)) ) Then
			strMAC = colActiveMAC.Item((Rnd*65536) mod intActiveMACCount)
			objFSO.OpenTextFile(strMACFile, 2).Write(Replace(strAllMACs, strMAC, "x" & strMAC))
			StartHostedNetwork(strMAC)
		End If
End Select

Function Execute(str, str1)
	With CreateObject("VBScript.RegExp")
		.Multiline = True: .Global = True: .Pattern = str1
		Set Execute = .Execute(str)
	End With
End Function

Function Replace(str, str1, str2)
	With CreateObject("VBScript.RegExp")
		.Multiline = True: .Global = True: .Pattern = str1
		Replace = .Replace(str, str2)
	End With
End Function

Function SchTasks(strArg)
	SchTasks = CreateObject("WScript.Shell").Run("%systemroot%\system32\schtasks.exe /tn " & BaseName & strArg, 0, False)
End Function

Function NetSh(strArg, blnWait)
	NetSh = CreateObject("WScript.Shell").Run("%systemroot%\system32\netsh.exe wlan " & strArg, 0, blnWait)
End Function

Function TaskEnabled
	With CreateObject("Microsoft.XMLDOM")
		If .LoadXML(CreateObject("WScript.Shell").Exec("%systemroot%\system32\schtasks.exe /tn " & BaseName & " /query /xml").StdOut.ReadAll) Then TaskEnabled = .selectSingleNode("/Task/Settings/Enabled").text Else TaskEnabled = False
	End With
End Function

Function StartHostedNetwork(strNewMAC)
	Dim strNewMACSSID: strNewMACSSID = Split(strNewMAC, ",")
	Dim strSSID: strSSID = "NZ@McD1"
	If UBound(strNewMACSSID) >= 1 Then
		strSSID = strNewMACSSID(1)
	End If	
	If UBound(strNewMACSSID) >= 0 Then
		strNewMAC = Replace(strNewMACSSID(0), "[:-]", "")
	End If
	Dim objNIC: Set objNIC = GetVirtualNIC
	If objNIC Is Nothing Then
		NetSh "stop hostednetwork", True
		NetSh "set hostednetwork disallow", True
		NetSh "set hostednetwork allow """ & strSSID & """ ""nintendozone""", True
		Set objNIC = GetVirtualNIC
	End If
	If objNIC Is Nothing Then
		Wscript.Echo "No hosted network compatible wireless interfaces found"
		StartHostedNetwork = False
	Else
		With GetObject("winmgmts:")
			SetSharing .ExecQuery("SELECT GUID FROM Win32_NetworkAdapter WHERE InterfaceIndex = " & .ExecQuery("SELECT InterfaceIndex FROM Win32_IP4RouteTable WHERE Destination = '0.0.0.0'").ItemIndex(0).InterfaceIndex).ItemIndex(0).GUID, objNIC.GUID
		End With
		NetSh "stop hostednetwork", True
		NetSh "set hostednetwork disallow", True
		ToggleMAC objNIC, strNewMAC
		NetSh "set hostednetwork allow """ & strSSID & """ ""nintendozone""", True
		Dim I: I=0
		While NetSh("start hostednetwork", True) = 1 Or I > 100
			WScript.Sleep 250
			I = I + 1
		Wend
		StartHostedNetwork = True
	End If
End Function

Sub StopHostedNetwork
	Dim objNIC: Set objNIC = GetVirtualNIC
	If objNIC Is Nothing Then
		WScript.Echo "Hosted network not started"
	Else
		NetSh "stop hostednetwork", True
		NetSh "set hostednetwork disallow", True
		SetSharing "", ""
		ToggleMAC objNIC, ""
	End If
End Sub

Function GetVirtualNIC
	With GetObject("winmgmts:").ExecQuery("SELECT GUID, Index, MACAddress, PNPDeviceID FROM Win32_NetworkAdapter WHERE ( PNPDeviceID LIKE '%\\VWIFIMP\\%' OR PNPDeviceID LIKE '%\\VWIFIMP_SAP\\%' ) AND MACAddress IS NOT NULL")
		If .Count = 0 Then
			Set GetVirtualNIC = Nothing
		Else
			Set GetVirtualNIC = .ItemIndex(0)
		End If
	End With
End Function

Sub SetSharing(strPublicGUID, strPrivateGUID)
	Dim obj, strGUID
	With CreateObject("HNetCfg.HNetShare.1")
		For Each obj in .EnumEveryConnection
			strGUID = .NetConnectionProps(obj).GUID
			With .INetSharingConfigurationForINetConnection(obj)
				If .SharingEnabled And ((.SharingConnectionType = 0 And strGUID <> strPublicGUID) Or (.SharingConnectionType = 1 And strGUID <> strPrivateGUID)) Then .DisableSharing
			End With
		Next
		For Each obj in .EnumEveryConnection
			strGUID = .NetConnectionProps(obj).GUID
			With .INetSharingConfigurationForINetConnection(obj)
				If strGUID = strPublicGUID Then .EnableSharing(0)
				If strGUID = strPrivateGUID Then .EnableSharing(1)
			End With
		Next
	End With
End Sub

Sub ToggleMAC(objVirtualNIC, strNewMAC)
	Dim intIndex
	With GetObject("winmgmts:").ExecQuery("SELECT Index FROM Win32_NetworkAdapter WHERE MACAddress like '%" & Mid(GetNonSafeMAC(objVirtualNIC.MACAddress),3,14) &"%' OR MACAddress like '%" & Mid(GetSafeMAC(objVirtualNIC.MACAddress),3,14) & "%'")
		If .Count = 1 Or .ItemIndex(0).Index <> objVirtualNIC.Index Then intIndex = 0 Else intIndex = 1
		With .ItemIndex(intIndex)
			CreateObject("WScript.Shell").RegWrite "HKLM\SYSTEM\CurrentControlSet\Control\Class\{4D36E972-E325-11CE-BFC1-08002BE10318}\" & String(4 - Len(.Index), "0") & .Index & "\NetworkAddress", GetSafeMAC(strNewMAC), "REG_SZ"
			.Disable: .Enable
		End With
	End With
End Sub

Function GetSafeMAC(str)
	If Len(str) > 0 Then GetSafeMAC = Left(str,1) & Hex((Eval("&h" & Mid(str,2,1)) OR 2) AND 254) & Right(str,Len(str)-2) Else GetSafeMAC = str
End Function

Function GetNonSafeMAC(str)
	If Len(str) > 0 Then GetNonSafeMAC = Left(str,1) & Hex(Eval("&h" & Mid(str,2,1)) AND 253) & Right(str,Len(str)-2) Else GetNonSafeMAC = str
End Function
